/*
 * Copyright (c) 2005-, Claybird
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:

 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Claybird nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#pragma once

struct CConfigFileListWindow:public IConfigConverter{
public:
	int Width;					//EBhE̕
	int Height;					//EBhE̍
	int TreeWidth;				//c[r[̕

	int SortColumn;				//ǂ̃JŃ\[g邩
	BOOL SortDescending;		//\[g̏E~
	int ListStyle;				//Xgr[̌`

	BOOL StoreSetting;			//EBhE̐ݒۑ

	int WindowPos_x;			//EBhE̍W(x)
	int WindowPos_y;			//EBhE̍W(y)
	BOOL StoreWindowPosition;	//EBhËʒuۑ

	BOOL IgnoreMeaninglessPath;	//󔒂.݂̂̃pXw͖
	FILELISTMODE FileListMode;	//t@C\̊Kw[h
	BOOL ExpandTree;			//NɃc[r[WJĂ
	BOOL DisplayFileSizeInByte;	//oCgPʂŃt@CTCY\L
	BOOL DisplayPathOnly;		//tpX̗Ƀt@C\Ȃ
	int ColumnOrderArray[FILEINFO_ITEM_COUNT];	//Xgr[J̕я
	int ColumnWidthArray[FILEINFO_ITEM_COUNT];	//Xgr[J̕
	BOOL ExitWithEscape;		//[ESC]L[ŏI
	BOOL DisableTab;			//^u\gȂȂTRUE
	BOOL KeepSingleInstance;	//EBhEɕۂȂTRUE
	BOOL DenyPathExt;			//%PATHEXT%Ŏw肳ꂽt@CJȂȂTRUE

	CString strCustomToolbarImage;	//JX^c[o[摜
	BOOL ShowToolbar;			//c[o[\ȂTRUE
	BOOL ShowTreeView;			//c[r[\ȂTRUE

	struct tagOpenAssoc{
		virtual ~tagOpenAssoc(){}
		CString Accept;
		CString Deny;
	}OpenAssoc;

	std::vector<CMenuCommandItem> MenuCommandArray;	//uvOŊJṽR}h
protected:
	virtual void load(CONFIG_SECTION&);	//ݒCONFIG_SECTIONǂݍ
	virtual void store(CONFIG_SECTION&)const;	//ݒCONFIG_SECTIONɏ
	void loadMenuCommand(CONFIG_SECTION&,CMenuCommandItem&);
	void storeMenuCommand(CONFIG_SECTION&,const CMenuCommandItem&)const;
public:
	virtual ~CConfigFileListWindow(){}
	virtual void load(CConfigManager&);
	virtual void store(CConfigManager&)const;
};

